<?php
/***************************************************************************
 *                        thanks.php
 *                        ---------------------------------
 *   begin                : Monday, 11 September 2006
 *   copyright            : (C) 2006 Alejandro Iannuzzi
 *
 *   $Id: thanks.php, v 0.2.0  2006/09/27 17:15 (GMT+10)
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_PRIVMSGS);
init_userprefs($userdata);
//
// End session management
//

// Set to 1 to use pop-ups instead of using the same window
$popup_enabled = 0;

if ($popup_enabled == 1) { $gen_simple_header = TRUE; }

$page_title = $lang['Thanks_title'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

if ($userdata['session_logged_in']) {

   // If p= is set
   if ( isset($HTTP_GET_VARS[POST_POST_URL])) {
      $post_id = intval($HTTP_GET_VARS[POST_POST_URL]);

      // Posts SQL
      $sql = "SELECT post_id, topic_id, poster_id, thanks_from_user_id
              FROM " . POSTS_TABLE . "
              WHERE post_id = " . $post_id;

      if ( !($result = $db->sql_query($sql)) ) {
         message_die(GENERAL_ERROR, "Could not obtain post information", '', __LINE__, __FILE__, $sql);
      }

      $post_row = $db->sql_fetchrow($result);
      $db->sql_freeresult($result);

      // If post_id exists
      if ($post_row) {

         // If the user isn't the user who made the post
         if ($userdata['user_id'] != $post_row['poster_id']) {

            // If the user isn't anonymous
            if ($post_row['poster_id'] != -1) {

               // If this is the first time this post is being thanked
               if ($post_row['thanks_from_user_id'] == null) {

                   // Update DB with the user_id and thanks count
                   $update_sql = "UPDATE " . POSTS_TABLE . "
                                  SET thanks_count = '1', thanks_from_user_id = " . $userdata['user_id'] . "
                                  WHERE post_id = " . $post_id;

                   if ( !($result = $db->sql_query($update_sql)) ) {
                      message_die(GENERAL_ERROR, 'Could not update posts table', '', __LINE__, __FILE__, $update_sql);
                   }

                   update_thanks ($db, $userdata['user_id'], $post_row['poster_id']);

                   $username_topic_title = get_username_and_topic_title ($db, $post_row['poster_id'], $post_row['topic_id']);

                   $l_message = $lang['Thanks_success_1'] . ' "' . $username_topic_title[0] . '" ' . $lang['Thanks_success_2'] . ' "' . $username_topic_title[1] . '" ' . $lang['Thanks_success_3'];
               }
               else {

                  // Check that this user hasn't thanked this post before
                  $thanked_users = explode("|",$post_row['thanks_from_user_id']);
                  $thanked_count = count($thanked_users);

                  $already_thanked = 0;

                  // Loop through all users who thanked the post
                  for ($x = 0; $x < $thanked_count; $x++) {
                     if ($thanked_users[$x] == $userdata['user_id']) {
                        $already_thanked = 1;
                     }
                  }

                  // If the user hasn't thanked this post
                  if ($already_thanked == 0) {

                     // Add them to the list and update thanked counter
                     $thanked_users[$thanked_count] = $userdata['user_id'];
                     $new_thanked_list = implode("|",$thanked_users);
                     $thanked_count++;

                     // Update DB with the user_id and thanks count
                     $update_sql = "UPDATE " . POSTS_TABLE . "
                                    SET thanks_count = " . $thanked_count . ", thanks_from_user_id = '" . $new_thanked_list . "'
                                    WHERE post_id = " . $post_id;

                     if ( !($result = $db->sql_query($update_sql)) ) {
                       message_die(GENERAL_ERROR, 'Could not update posts table', '', __LINE__, __FILE__, $update_sql);
                     }

                     update_thanks ($db, $userdata['user_id'], $post_row['poster_id']);

                     $username_topic_title = get_username_and_topic_title ($db, $post_row['poster_id'], $post_row['topic_id']);

                     $l_message = $lang['Thanks_success_1'] . ' "' . $username_topic_title[0] . '" ' . $lang['Thanks_success_2'] . ' "' . $username_topic_title[1] . '" ' . $lang['Thanks_success_3'];
                  }
                  else{
                     $l_message = $lang['Thanks_already_thanked'];
                  }
               }
            }
            else {
               $l_message = $lang['Thanks_anonymous'];
            }
         }
         else {
            $l_message = $lang['Thanks_self'];
         }
      }
      else {
         $l_message = $lang['Thanks_no_such_post'];
      }
   }
   else {
      $l_message = $lang['Thanks_no_post_specified'];
   }
}
else {
   $l_message = $lang['Thanks_not_logged_in'];
}

if ($popup_enabled == 1) {
   $template->set_filenames(array(
      'body' => 'thanks_popup.tpl')
   );

   $template->assign_vars(array(
      'L_CLOSE_WINDOW' => $lang['Close_window'],
      'L_MESSAGE' => $l_message)
   );
}
else {
   $template->set_filenames(array(
      'body' => 'thanks.tpl')
   );

   $post_url = append_sid("viewtopic.$phpEx?p=" . $post_id . "#" . $post_id);
   $l_message .= '<BR /><BR />' . $lang['Thanks_success_redirect'];

   $template->assign_vars(array(
      'L_BACK_TEXT' => $lang['Thanks_success_back'],
      'L_MESSAGE' => $l_message,
      'U_BACK_LINK' => $post_url)
   );
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);


// Retrieves the username and topic title from the database
function get_username_and_topic_title ($db, $poster_id, $topic_id) {

   // Users SQL
   $sql = "SELECT username
           FROM " . USERS_TABLE . "
           WHERE user_id = " . $poster_id;

   if ( !($result = $db->sql_query($sql)) ) {
      message_die(GENERAL_ERROR, "Could not obtain user information", '', __LINE__, __FILE__, $sql);
   }

   $user_row = $db->sql_fetchrow($result);
   $db->sql_freeresult($result);

   // Topics SQL
   $sql = "SELECT topic_title
           FROM " . TOPICS_TABLE . "
           WHERE topic_id = " . $topic_id;

   if ( !($result = $db->sql_query($sql)) ) {
      message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql);
   }

   $topic_row = $db->sql_fetchrow($result);
   $db->sql_freeresult($result);

   $results_array = array();
   $results_array[0] = $user_row['username'];
   $results_array[1] = $topic_row['topic_title'];

   return $results_array;
}


// Updates the database with the thanks given and received
function update_thanks ($db, $from_user, $to_user) {

   // From Users SQL
   $sql = "SELECT user_thanks_given
           FROM " . USERS_TABLE . "
           WHERE user_id = " . $from_user;

   if ( !($result = $db->sql_query($sql)) ) {
      message_die(GENERAL_ERROR, "Could not obtain user information", '', __LINE__, __FILE__, $sql);
   }

   $from_user_row = $db->sql_fetchrow($result);
   $db->sql_freeresult($result);

   $thanks_given = $from_user_row['user_thanks_given'] + 1;

   // Update DB with the new thanks given
   $update_sql = "UPDATE " . USERS_TABLE . "
                  SET user_thanks_given = '" . $thanks_given . "'
                  WHERE user_id = " . $from_user;

   if ( !($result = $db->sql_query($update_sql)) ) {
      message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $update_sql);
   }

   // To Users SQL
   $sql = "SELECT user_thanks_received
           FROM " . USERS_TABLE . "
           WHERE user_id = " . $to_user;

   if ( !($result = $db->sql_query($sql)) ) {
      message_die(GENERAL_ERROR, "Could not obtain user information", '', __LINE__, __FILE__, $sql);
   }

   $to_user_row = $db->sql_fetchrow($result);
   $db->sql_freeresult($result);

   $thanks_received = $to_user_row['user_thanks_received'] + 1;

   // Update DB with the new thanks given
   $update_sql = "UPDATE " . USERS_TABLE . "
                  SET user_thanks_received = '" . $thanks_received . "'
                  WHERE user_id = " . $to_user;

   if ( !($result = $db->sql_query($update_sql)) ) {
      message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $update_sql);
   }
}

?>